Index: channels/chan_features.c
===================================================================
--- channels/chan_features.c	(revision 34061)
+++ channels/chan_features.c	(working copy)
@@ -94,7 +94,7 @@
 #define SUB_CALLWAIT	1			/* Call-Waiting call on hold */
 #define SUB_THREEWAY	2			/* Three-way call */
 
-static struct ast_channel *features_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *features_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int features_digit(struct ast_channel *ast, char digit);
 static int features_call(struct ast_channel *ast, char *dest, int timeout);
 static int features_hangup(struct ast_channel *ast);
@@ -188,8 +188,8 @@
 			p->subs[index].owner->timingfd = p->subchan->timingfd;
 			p->subs[index].owner->alertpipe[0] = p->subchan->alertpipe[0];
 			p->subs[index].owner->alertpipe[1] = p->subchan->alertpipe[1];
-			if (p->subs[index].owner->nativeformats != p->subchan->readformat) {
-				p->subs[index].owner->nativeformats = p->subchan->readformat;
+			if (!(ast_codec_pref_bits(&p->subs[index].owner->nativeformats) & p->subchan->readformat)) {
+				ast_codec_pref_append(&p->subs[index].owner->nativeformats, p->subchan->readformat);
 				if (p->subs[index].owner->readformat)
 					ast_set_read_format(p->subs[index].owner, p->subs[index].owner->readformat);
 				if (p->subs[index].owner->writeformat)
@@ -378,7 +378,7 @@
 	return 0;
 }
 
-static struct feature_pvt *features_alloc(char *data, int format)
+static struct feature_pvt *features_alloc(char *data, const struct ast_codec_pref *formats)
 {
 	struct feature_pvt *tmp;
 	char *dest=NULL;
@@ -407,7 +407,7 @@
 	}
 	AST_LIST_UNLOCK(&features);
 	if (!tmp) {
-		chan = ast_request(tech, format, dest, &status);
+		chan = ast_request(tech, formats, dest, &status);
 		if (!chan) {
 			ast_log(LOG_NOTICE, "Unable to allocate subchannel '%s/%s'\n", tech, dest);
 			return NULL;
@@ -463,7 +463,7 @@
 	tmp->rawwriteformat = p->subchan->rawwriteformat;
 	tmp->readformat = p->subchan->readformat;
 	tmp->rawreadformat = p->subchan->rawreadformat;
-	tmp->nativeformats = p->subchan->readformat;
+	ast_codec_pref_append(&tmp->nativeformats, p->subchan->readformat);
 	tmp->tech_pvt = p;
 	p->subs[index].owner = tmp;
 	if (!p->owner)
@@ -476,12 +476,12 @@
 }
 
 
-static struct ast_channel *features_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *features_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
 	struct feature_pvt *p;
 	struct ast_channel *chan = NULL;
 
-	p = features_alloc(data, format);
+	p = features_alloc(data, formats);
 	if (p && !p->subs[SUB_REAL].owner)
 		chan = features_new(p, AST_STATE_DOWN, SUB_REAL);
 	if (chan)
Index: channels/chan_h323.c
===================================================================
--- channels/chan_h323.c	(revision 34061)
+++ channels/chan_h323.c	(working copy)
@@ -219,7 +219,7 @@
 static int restart_monitor(void);
 static int h323_do_reload(void);
 
-static struct ast_channel *oh323_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *oh323_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int oh323_digit(struct ast_channel *c, char digit);
 static int oh323_call(struct ast_channel *c, char *dest, int timeout);
 static int oh323_hangup(struct ast_channel *c);
@@ -252,10 +252,11 @@
 /* Channel and private structures should be already locked */
 static void __oh323_update_info(struct ast_channel *c, struct oh323_pvt *pvt)
 {
-	if (c->nativeformats != pvt->nativeformats) {
+	if (ast_codec_pref_bits(&c->nativeformats) != pvt->nativeformats) {
 		if (h323debug)
 			ast_log(LOG_DEBUG, "Preparing %s for new native format\n", c->name);
-		c->nativeformats = pvt->nativeformats;
+		ast_codec_pref_init(&c->nativeformats);
+		ast_codec_pref_append_missing2(&c->nativeformats, pvt->nativeformats);
 		ast_set_read_format(c, c->readformat);
 		ast_set_write_format(c, c->writeformat);
 	}
@@ -577,15 +578,15 @@
 	if (pvt->owner) {
 		/* We already hold the channel lock */
 		if (f->frametype == AST_FRAME_VOICE) {
-			if (f->subclass != pvt->owner->nativeformats) {
+			if (!(f->subclass & pvt->owner->nativeformats.audio_bits)) {
 				/* Try to avoid deadlock */
 				if (ast_mutex_trylock(&pvt->owner->lock)) {
 					ast_log(LOG_NOTICE, "Format changed but channel is locked. Ignoring frame...\n");
 					return &ast_null_frame;
 				}
 				ast_log(LOG_DEBUG, "Oooh, format changed to %d\n", f->subclass);
-				pvt->owner->nativeformats = f->subclass;
-				pvt->nativeformats = f->subclass;
+				ast_codec_pref_append(&pvt->owner->nativeformats, f->subclass);
+				pvt->nativeformats |= f->subclass;
 				ast_set_read_format(pvt->owner, pvt->owner->readformat);
 				ast_set_write_format(pvt->owner, pvt->owner->writeformat);
 				ast_mutex_unlock(&pvt->owner->lock);
@@ -630,9 +631,9 @@
 			return 0;
 		}
 	} else {
-		if (!(frame->subclass & c->nativeformats)) {
+		if (!(frame->subclass & c->nativeformats.audio_bits)) {
 			ast_log(LOG_WARNING, "Asked to transmit frame type %d, while native formats is %d (read/write = %d/%d)\n",
-				frame->subclass, c->nativeformats, c->readformat, c->writeformat);
+				frame->subclass, ast_codec_pref_bits(&c->nativeformats), c->readformat, c->writeformat);
 			return 0;
 		}
 	}
@@ -753,12 +754,12 @@
 	if (ch) {
 		ch->tech = &oh323_tech;
 		ast_string_field_build(ch, name, "H323/%s", host);
-		ch->nativeformats = pvt->options.capability;
-		if (!ch->nativeformats) {
-			ch->nativeformats = global_options.capability;
+		ast_codec_pref_append_missing2(&ch->nativeformats, pvt->options.capability);
+		if (!ast_codec_pref_bits(&ch->nativeformats)) {
+			ast_codec_pref_append(&ch->nativeformats, global_options.capability);
 		}
-		pvt->nativeformats = ch->nativeformats;
-		fmt = ast_best_codec(ch->nativeformats);
+		pvt->nativeformats = ast_codec_pref_bits(&ch->nativeformats);
+		fmt = ast_best_codec(ch->nativeformats.audio_bits);
 		ch->fds[0] = ast_rtp_fd(pvt->rtp);
 		if (state == AST_STATE_RING) {
 			ch->rings = 1;
@@ -1029,9 +1030,8 @@
 		return 0;
 	}
 }
-static struct ast_channel *oh323_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *oh323_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
-	int oldformat;
 	struct oh323_pvt *pvt;
 	struct ast_channel *tmpc = NULL;
 	char *dest = (char *)data;
@@ -1039,18 +1039,12 @@
 	char *h323id = NULL;
 	char tmp[256], tmp1[256];
 	
-	ast_log(LOG_DEBUG, "type=%s, format=%d, data=%s.\n", type, format, (char *)data);
+	ast_log(LOG_DEBUG, "type=%s, format=%d, data=%s.\n", type, ast_codec_pref_dump(tmp, sizeof(tmp), formats), (char *)data);
 	pvt = oh323_alloc(0);
 	if (!pvt) {
 		ast_log(LOG_WARNING, "Unable to build pvt data for '%s'\n", (char *)data);
 		return NULL;
 	}	
-	oldformat = format;
-	format &= ((AST_FORMAT_MAX_AUDIO << 1) - 1);
-	if (!format) {
-		ast_log(LOG_NOTICE, "Asked to get a channel of unsupported format '%d'\n", format);
-		return NULL;
-	}
 	strncpy(tmp, dest, sizeof(tmp) - 1);	
 	host = strchr(tmp, '@');
 	if (host) {
@@ -1186,14 +1180,6 @@
 }
 
 /**
- * Definition taken from rtp.c for rtpPayloadType because we need it here.
- */
-struct rtpPayloadType {
-	int isAstFormat;        /* whether the following code is an AST_FORMAT */
-	int code;
-};
-
-/**
   * Call-back function passing remote ip/port information from H.323 to asterisk 
   *
   * Returns nothing 
@@ -1220,7 +1206,8 @@
 	rtptype = ast_rtp_lookup_pt(pvt->rtp, pt);
 	pvt->nativeformats = rtptype.code;
 	if (pvt->owner && !ast_mutex_trylock(&pvt->owner->lock)) {
-		pvt->owner->nativeformats = pvt->nativeformats;
+		ast_codec_pref_init(&pvt->owner->nativeformats);
+		ast_codec_pref_append_missing2(&pvt->owner->nativeformats, pvt->nativeformats);
 		ast_set_read_format(pvt->owner, pvt->owner->readformat);
 		ast_set_write_format(pvt->owner, pvt->owner->writeformat);
 		if (pvt->options.progress_audio)
@@ -2310,7 +2297,7 @@
 	}
 }
 
-static int oh323_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, int codecs, int nat_active)
+static int oh323_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, const struct ast_codec_pref *codecs, int nat_active)
 {
 	/* XXX Deal with Video */
 	struct oh323_pvt *pvt;
Index: channels/chan_iax2.c
===================================================================
--- channels/chan_iax2.c	(revision 34061)
+++ channels/chan_iax2.c	(working copy)
@@ -779,7 +779,7 @@
 static int send_command_immediate(struct chan_iax2_pvt *, char, int, unsigned int, const unsigned char *, int, int);
 static int send_command_locked(unsigned short callno, char, int, unsigned int, const unsigned char *, int, int);
 static int send_command_transfer(struct chan_iax2_pvt *, char, int, unsigned int, const unsigned char *, int);
-static struct ast_channel *iax2_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *iax2_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static struct ast_frame *iax2_read(struct ast_channel *c);
 static struct iax2_peer *build_peer(const char *name, struct ast_variable *v, int temponly);
 static struct iax2_user *build_user(const char *name, struct ast_variable *v, int temponly);
@@ -1983,7 +1983,7 @@
 	char iabuf[INET_ADDRSTRLEN];
 	struct iax2_peer *peer;
 	char codec_buf[512];
-	int x = 0, codec = 0, load_realtime = 0;
+	int load_realtime = 0;
 
 	if (argc < 4)
 		return RESULT_SHOWUSAGE;
@@ -2008,19 +2008,9 @@
 		ast_getformatname_multiple(codec_buf, sizeof(codec_buf) -1, peer->capability);
 		ast_cli(fd, "%s\n", codec_buf);
 
-		ast_cli(fd, "  Codec Order  : (");
-		for(x = 0; x < 32 ; x++) {
-			codec = ast_codec_pref_index(&peer->prefs,x);
-			if(!codec)
-				break;
-			ast_cli(fd, "%s", ast_getformatname(codec));
-			if(x < 31 && ast_codec_pref_index(&peer->prefs,x+1))
-				ast_cli(fd, "|");
-		}
-
-		if (!x)
-			ast_cli(fd, "none");
-		ast_cli(fd, ")\n");
+		ast_cli(fd, "  Codec Order  : ");
+		ast_codec_pref_dump(codec_buf, sizeof(codec_buf), &peer->prefs);
+		ast_cli(fd, "%s\n", codec_buf);
 
 		ast_cli(fd, "  Status       : ");
 		peer_status(peer, status, sizeof(status));	
@@ -2651,7 +2641,7 @@
 			memcpy(&sin->sin_addr, hp->h_addr, sizeof(sin->sin_addr));
 			sin->sin_port = htons(IAX_DEFAULT_PORTNO);
 			/* use global iax prefs for unknown peer/user */
-			ast_codec_pref_convert(&prefs, cai->prefs, sizeof(cai->prefs), 1);
+			ast_codec_pref_convert_to_buf(&prefs, cai->prefs, sizeof(cai->prefs));
 			return 0;
 		} else {
 			ast_log(LOG_WARNING, "No such host: %s\n", peername);
@@ -2680,7 +2670,7 @@
 	cai->capability = peer->capability;
 	cai->encmethods = peer->encmethods;
 	cai->sockfd = peer->sockfd;
-	ast_codec_pref_convert(&peer->prefs, cai->prefs, sizeof(cai->prefs), 1);
+	ast_codec_pref_convert_to_buf(&peer->prefs, cai->prefs, sizeof(cai->prefs));
 	ast_copy_string(cai->context, peer->context, sizeof(cai->context));
 	ast_copy_string(cai->peercontext, peer->peercontext, sizeof(cai->peercontext));
 	ast_copy_string(cai->username, peer->username, sizeof(cai->username));
@@ -2937,7 +2927,7 @@
 	if (pds.password)
 		ast_copy_string(iaxs[callno]->secret, pds.password, sizeof(iaxs[callno]->secret));
 
-	iax_ie_append_int(&ied, IAX_IE_FORMAT, c->nativeformats);
+	iax_ie_append_int(&ied, IAX_IE_FORMAT, ast_codec_pref_bits(&c->nativeformats));
 	iax_ie_append_int(&ied, IAX_IE_CAPABILITY, iaxs[callno]->capability);
 	iax_ie_append_short(&ied, IAX_IE_ADSICPE, c->adsicpe);
 	iax_ie_append_int(&ied, IAX_IE_DATETIME, iax2_datetime(cai.timezone));
@@ -3104,13 +3094,13 @@
 			}
 			return AST_BRIDGE_FAILED_NOWARN;
 		}
-		if (c0->nativeformats != c1->nativeformats) {
+		if (!ast_codec_pref_eq_noorder(&c0->nativeformats, &c1->nativeformats)) {
 			if (option_verbose > 2) {
 				char buf0[255];
 				char buf1[255];
-				ast_getformatname_multiple(buf0, sizeof(buf0) -1, c0->nativeformats);
-				ast_getformatname_multiple(buf1, sizeof(buf1) -1, c1->nativeformats);
-				ast_verbose(VERBOSE_PREFIX_3 "Operating with different codecs %d[%s] %d[%s] , can't native bridge...\n", c0->nativeformats, buf0, c1->nativeformats, buf1);
+				ast_codec_pref_dump(buf0, sizeof(buf0), &c0->nativeformats);
+				ast_codec_pref_dump(buf1, sizeof(buf1), &c1->nativeformats);
+				ast_verbose(VERBOSE_PREFIX_3 "Operating with different codecs %d[%s] %d[%s] , can't native bridge...\n", ast_codec_pref_bits(&c0->nativeformats), buf0, ast_codec_pref_bits(&c1->nativeformats), buf1);
 			}
 			/* Remove from native mode */
 			lock_both(callno0, callno1);
@@ -3277,7 +3267,7 @@
 		tmp->tech = &iax2_tech;
 		ast_string_field_build(tmp, name, "IAX2/%s-%d", i->host, i->callno);
 		/* We can support any format by default, until we get restricted */
-		tmp->nativeformats = capability;
+		ast_codec_pref_set2(&tmp->nativeformats, capability);
 		tmp->readformat = ast_best_codec(capability);
 		tmp->writeformat = ast_best_codec(capability);
 		tmp->tech_pvt = CALLNO_TO_PTR(i->callno);
@@ -4701,8 +4691,8 @@
 
 	/* Use provided preferences until told otherwise for actual preferences */
 	if(ies->codec_prefs) {
-		ast_codec_pref_convert(&iaxs[callno]->rprefs, ies->codec_prefs, 32, 0);
-		ast_codec_pref_convert(&iaxs[callno]->prefs, ies->codec_prefs, 32, 0);
+		ast_codec_pref_convert_from_buf(&iaxs[callno]->rprefs, ies->codec_prefs, 32);
+		ast_codec_pref_convert_from_buf(&iaxs[callno]->prefs, ies->codec_prefs, 32);
 	}
 
 	if (!gotcapability) 
@@ -6688,11 +6678,11 @@
 						}
 						if (iaxs[fr->callno]) {
 							if (iaxs[fr->callno]->owner) {
-								orignative = iaxs[fr->callno]->owner->nativeformats;
-								iaxs[fr->callno]->owner->nativeformats = f.subclass;
+								orignative = ast_codec_pref_bits(&iaxs[fr->callno]->owner->nativeformats);
+								ast_codec_pref_set2(&iaxs[fr->callno]->owner->nativeformats, f.subclass);
 								if (iaxs[fr->callno]->owner->readformat)
 									ast_set_read_format(iaxs[fr->callno]->owner, iaxs[fr->callno]->owner->readformat);
-								iaxs[fr->callno]->owner->nativeformats = orignative;
+								ast_codec_pref_set2(&iaxs[fr->callno]->owner->nativeformats, orignative);
 								ast_mutex_unlock(&iaxs[fr->callno]->owner->lock);
 							}
 						} else {
@@ -6837,8 +6827,8 @@
 							using_prefs = "mine";
 							/* If the information elements are in here... use them */
 							if (ies.codec_prefs)
-								ast_codec_pref_convert(&iaxs[fr->callno]->rprefs, ies.codec_prefs, 32, 0);
-							if (ast_codec_pref_index(&iaxs[fr->callno]->rprefs, 0)) {
+								ast_codec_pref_convert_from_buf(&iaxs[fr->callno]->rprefs, ies.codec_prefs, 32);
+							if (ast_codec_pref_index_audio(&iaxs[fr->callno]->rprefs, 0)) {
 								/* If we are codec_first_choice we let the caller have the 1st shot at picking the codec.*/
 								if (ast_test_flag(iaxs[fr->callno], IAX_CODEC_USER_FIRST)) {
 									pref = iaxs[fr->callno]->rprefs;
@@ -6881,7 +6871,7 @@
 										strcpy(host_pref_buf,"disabled");
 									} else {
 										using_prefs = "mine";
-										if (ast_codec_pref_index(&iaxs[fr->callno]->rprefs, 0)) {
+										if (ast_codec_pref_index_audio(&iaxs[fr->callno]->rprefs, 0)) {
 											/* Do the opposite of what we tried above. */
 											if (ast_test_flag(iaxs[fr->callno], IAX_CODEC_USER_FIRST)) {
 												pref = iaxs[fr->callno]->prefs;								
@@ -7032,7 +7022,7 @@
 					iaxs[fr->callno]->peerformat = ies.format;
 				} else {
 					if (iaxs[fr->callno]->owner)
-						iaxs[fr->callno]->peerformat = iaxs[fr->callno]->owner->nativeformats;
+						iaxs[fr->callno]->peerformat = ast_codec_pref_bits(&iaxs[fr->callno]->owner->nativeformats);
 					else
 						iaxs[fr->callno]->peerformat = iaxs[fr->callno]->capability;
 				}
@@ -7049,9 +7039,11 @@
 					ast_set_flag(&iaxs[fr->callno]->state, IAX_STATE_STARTED);
 					if (iaxs[fr->callno]->owner) {
 						/* Switch us to use a compatible format */
-						iaxs[fr->callno]->owner->nativeformats = iaxs[fr->callno]->peerformat;
-						if (option_verbose > 2)
-							ast_verbose(VERBOSE_PREFIX_3 "Format for call is %s\n", ast_getformatname(iaxs[fr->callno]->owner->nativeformats));
+						ast_codec_pref_set2(&iaxs[fr->callno]->owner->nativeformats, iaxs[fr->callno]->peerformat);
+						if (option_verbose > 2) {
+							char buf[512];
+							ast_verbose(VERBOSE_PREFIX_3 "Format for call is %s\n", ast_codec_pref_dump(buf, sizeof(buf), &iaxs[fr->callno]->owner->nativeformats));
+						}
 retryowner2:
 						if (ast_mutex_trylock(&iaxs[fr->callno]->owner->lock)) {
 							ast_mutex_unlock(&iaxsl[fr->callno]);
@@ -7241,8 +7233,8 @@
 					} else {
 						using_prefs = "mine";
 						if (ies.codec_prefs)
-							ast_codec_pref_convert(&iaxs[fr->callno]->rprefs, ies.codec_prefs, 32, 0);
-						if (ast_codec_pref_index(&iaxs[fr->callno]->rprefs, 0)) {
+							ast_codec_pref_convert_from_buf(&iaxs[fr->callno]->rprefs, ies.codec_prefs, 32);
+						if (ast_codec_pref_index_audio(&iaxs[fr->callno]->rprefs, 0)) {
 							if (ast_test_flag(iaxs[fr->callno], IAX_CODEC_USER_FIRST)) {
 								pref = iaxs[fr->callno]->rprefs;
 								using_prefs = "caller";
@@ -7287,7 +7279,7 @@
 									strcpy(host_pref_buf,"disabled");
 								} else {
 									using_prefs = "mine";
-									if (ast_codec_pref_index(&iaxs[fr->callno]->rprefs, 0)) {
+									if (ast_codec_pref_index_audio(&iaxs[fr->callno]->rprefs, 0)) {
 										/* Do the opposite of what we tried above. */
 										if (ast_test_flag(iaxs[fr->callno], IAX_CODEC_USER_FIRST)) {
 											pref = iaxs[fr->callno]->prefs;						
@@ -8001,11 +7993,9 @@
 	}
 }
 
-static struct ast_channel *iax2_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *iax2_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
 	int callno;
-	int res;
-	int fmt, native;
 	struct sockaddr_in sin;
 	struct ast_channel *c;
 	struct parsed_dial_string pds;
@@ -8059,22 +8049,8 @@
 
 	if (c) {
 		/* Choose a format we can live with */
-		if (c->nativeformats & format) 
-			c->nativeformats &= format;
-		else {
-			native = c->nativeformats;
-			fmt = format;
-			res = ast_translator_best_choice(&fmt, &native);
-			if (res < 0) {
-				ast_log(LOG_WARNING, "Unable to create translator path for %s to %s on %s\n",
-					ast_getformatname(c->nativeformats), ast_getformatname(fmt), c->name);
-				ast_hangup(c);
-				return NULL;
-			}
-			c->nativeformats = native;
-		}
-		c->readformat = ast_best_codec(c->nativeformats);
-		c->writeformat = c->readformat;
+		ast_codec_pref_remove2(&c->nativeformats, ~ast_codec_pref_bits(formats));
+		c->readformat = c->writeformat = ast_codec_pref_index_audio(&c->nativeformats, 0);
 	}
 
 	return c;
@@ -9476,7 +9452,7 @@
 			*ptr = '\0';
 		}
 		index = atoi(codecnum);
-		if((codec = ast_codec_pref_index(&peer->prefs, index))) {
+		if((codec = ast_codec_pref_index_audio(&peer->prefs, index))) {
 			ast_copy_string(buf, ast_getformatname(codec), len);
 		}
 	}
Index: channels/chan_local.c
===================================================================
--- channels/chan_local.c	(revision 34061)
+++ channels/chan_local.c	(working copy)
@@ -66,7 +66,7 @@
 
 #define IS_OUTBOUND(a,b) (a == b->chan ? 1 : 0)
 
-static struct ast_channel *local_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *local_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int local_digit(struct ast_channel *ast, char digit);
 static int local_call(struct ast_channel *ast, char *dest, int timeout);
 static int local_hangup(struct ast_channel *ast);
@@ -484,7 +484,7 @@
 }
 
 /*! \brief Create a call structure */
-static struct local_pvt *local_alloc(const char *data, int format)
+static struct local_pvt *local_alloc(const char *data, const struct ast_codec_pref *formats)
 {
 	struct local_pvt *tmp;
 	char *c;
@@ -505,7 +505,7 @@
 	if (c)
 		*c++ = '\0';
 	ast_copy_string(tmp->context, c ? c : "default", sizeof(tmp->context));
-	tmp->reqformat = format;
+	tmp->reqformat = ast_codec_pref_bits(formats);
 	if (!ast_exists_extension(NULL, tmp->context, tmp->exten, 1, NULL)) {
 		ast_log(LOG_NOTICE, "No such extension/context %s@%s creating local channel\n", tmp->exten, tmp->context);
 		ast_mutex_destroy(&tmp->lock);
@@ -539,8 +539,8 @@
 	} 
 
 	tmp2->tech = tmp->tech = &local_tech;
-	tmp->nativeformats = p->reqformat;
-	tmp2->nativeformats = p->reqformat;
+	ast_codec_pref_append_missing2(&tmp->nativeformats, p->reqformat);
+	ast_codec_pref_append_missing2(&tmp2->nativeformats, p->reqformat);
 	ast_string_field_build(tmp, name, "Local/%s@%s-%04x,1", p->exten, p->context, randnum);
 	ast_string_field_build(tmp2, name, "Local/%s@%s-%04x,2", p->exten, p->context, randnum);
 	ast_setstate(tmp, state);
@@ -570,12 +570,12 @@
 
 
 /*! \brief Part of PBX interface */
-static struct ast_channel *local_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *local_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
 	struct local_pvt *p;
 	struct ast_channel *chan = NULL;
 
-	p = local_alloc(data, format);
+	p = local_alloc(data, formats);
 	if (p)
 		chan = local_new(p, AST_STATE_DOWN);
 	return chan;
Index: channels/chan_mgcp.c
===================================================================
--- channels/chan_mgcp.c	(revision 34061)
+++ channels/chan_mgcp.c	(working copy)
@@ -491,7 +491,7 @@
 static int mgcp_do_reload(void);
 static int mgcp_reload(int fd, int argc, char *argv[]);
 
-static struct ast_channel *mgcp_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *mgcp_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int mgcp_call(struct ast_channel *ast, char *dest, int timeout);
 static int mgcp_hangup(struct ast_channel *ast);
 static int mgcp_answer(struct ast_channel *ast);
@@ -1225,9 +1225,10 @@
 	if (sub->owner) {
 		/* We already hold the channel lock */
 		if (f->frametype == AST_FRAME_VOICE) {
-			if (f->subclass != sub->owner->nativeformats) {
+			if (f->subclass != sub->owner->nativeformats.audio_bits) {
 				ast_log(LOG_DEBUG, "Oooh, format changed to %d\n", f->subclass);
-				sub->owner->nativeformats = f->subclass;
+/*				ast_codec_pref_init(&sub->owner->nativeformats);*/
+				ast_codec_pref_append(&sub->owner->nativeformats, f->subclass);
 				ast_set_read_format(sub->owner, sub->owner->readformat);
 				ast_set_write_format(sub->owner, sub->owner->writeformat);
 			}
@@ -1266,9 +1267,9 @@
 			return 0;
 		}
 	} else {
-		if (!(frame->subclass & ast->nativeformats)) {
+		if (!(frame->subclass & ast_codec_pref_bits(&ast->nativeformats))) {
 			ast_log(LOG_WARNING, "Asked to transmit frame type %d, while native formats is %d (read/write = %d/%d)\n",
-				frame->subclass, ast->nativeformats, ast->readformat, ast->writeformat);
+				frame->subclass, ast_codec_pref_bits(&ast->nativeformats), ast->readformat, ast->writeformat);
 			return -1;
 		}
 	}
@@ -1448,10 +1449,10 @@
 	tmp = ast_channel_alloc(1);
 	if (tmp) {
 		tmp->tech = &mgcp_tech;
-		tmp->nativeformats = i->capability;
-		if (!tmp->nativeformats)
-			tmp->nativeformats = capability;
-		fmt = ast_best_codec(tmp->nativeformats);
+		ast_codec_pref_set2(&tmp->nativeformats, i->capability);
+		if (!ast_codec_pref_bits(&tmp->nativeformats))
+			ast_codec_pref_set2(&tmp->nativeformats, capability);
+		fmt = ast_best_codec(tmp->nativeformats.audio_bits);
 		ast_string_field_build(tmp, name, "MGCP/%s@%s-%d", i->name, i->parent->name, sub->id);
 		if (sub->rtp)
 			tmp->fds[0] = ast_rtp_fd(sub->rtp);
@@ -3552,20 +3553,13 @@
 	return 0;
 }
 
-static struct ast_channel *mgcp_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *mgcp_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
-	int oldformat;
 	struct mgcp_subchannel *sub;
 	struct ast_channel *tmpc = NULL;
 	char tmp[256];
 	char *dest = data;
 
-	oldformat = format;
-	format &= capability;
-	if (!format) {
-		ast_log(LOG_NOTICE, "Asked to get a channel of unsupported format '%d'\n", format);
-		return NULL;
-	}
 	ast_copy_string(tmp, dest, sizeof(tmp));
 	if (ast_strlen_zero(tmp)) {
 		ast_log(LOG_NOTICE, "MGCP Channels require an endpoint\n");
@@ -3996,13 +3990,13 @@
 	return NULL;
 }
 
-static int mgcp_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, int codecs, int nat_active)
+static int mgcp_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, const struct ast_codec_pref *codecs, int nat_active)
 {
 	/* XXX Is there such thing as video support with MGCP? XXX */
 	struct mgcp_subchannel *sub;
 	sub = chan->tech_pvt;
 	if (sub && !sub->alreadygone) {
-		transmit_modify_with_sdp(sub, rtp, codecs);
+		transmit_modify_with_sdp(sub, rtp, ast_codec_pref_bits(codecs));
 		return 0;
 	}
 	return -1;
Index: channels/chan_oss.c
===================================================================
--- channels/chan_oss.c	(revision 34061)
+++ channels/chan_oss.c	(working copy)
@@ -396,7 +396,7 @@
 
 static int setformat(struct chan_oss_pvt *o, int mode);
 
-static struct ast_channel *oss_request(const char *type, int format, void *data
+static struct ast_channel *oss_request(const char *type, const struct ast_codec_pref *formats, void *data
 , int *cause);
 static int oss_digit(struct ast_channel *c, char digit);
 static int oss_text(struct ast_channel *c, const char *text);
@@ -980,7 +980,7 @@
 	if (o->sounddev < 0)
 		setformat(o, O_RDWR);
 	c->fds[0] = o->sounddev; /* -1 if device closed, override later */
-	c->nativeformats = AST_FORMAT_SLINEAR;
+	ast_codec_pref_append(&c->nativeformats, AST_FORMAT_SLINEAR);
 	c->readformat = AST_FORMAT_SLINEAR;
 	c->writeformat = AST_FORMAT_SLINEAR;
 	c->tech_pvt = o;
@@ -1020,7 +1020,7 @@
 }
 
 static struct ast_channel *oss_request(const char *type,
-	int format, void *data, int *cause)
+	const struct ast_codec_pref *formats, void *data, int *cause)
 {
 	struct ast_channel *c;
 	struct chan_oss_pvt *o = find_desc(data);
@@ -1030,10 +1030,6 @@
 	if (o == NULL) {
 		ast_log(LOG_NOTICE, "Device %s not found\n", (char *)data);
 		/* XXX we could default to 'dsp' perhaps ? */
-		return NULL;
-	}
-	if ((format & AST_FORMAT_SLINEAR) == 0) {
-		ast_log(LOG_NOTICE, "Format 0x%x unsupported\n", format);
 		return NULL;
 	}
 	if (o->owner) {
Index: channels/chan_phone.c
===================================================================
--- channels/chan_phone.c	(revision 34061)
+++ channels/chan_phone.c	(working copy)
@@ -159,7 +159,7 @@
 static char cid_num[AST_MAX_EXTENSION];
 static char cid_name[AST_MAX_EXTENSION];
 
-static struct ast_channel *phone_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *phone_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause);
 static int phone_digit(struct ast_channel *ast, char digit);
 static int phone_call(struct ast_channel *ast, char *dest, int timeout);
 static int phone_hangup(struct ast_channel *ast);
@@ -829,20 +829,20 @@
 		/* XXX Switching formats silently causes kernel panics XXX */
 		if (i->mode == MODE_FXS &&
 		    ioctl(i->fd, PHONE_QUERY_CODEC, &codec) == 0) {
-			if (codec.type == LINEAR16)
-				tmp->nativeformats =
+			if (codec.type == LINEAR16) {
+				ast_codec_pref_append(&tmp->nativeformats, AST_FORMAT_SLINEAR);
 				tmp->rawreadformat =
 				tmp->rawwriteformat =
 				AST_FORMAT_SLINEAR;
-			else {
-				tmp->nativeformats =
+			} else {
+				ast_codec_pref_append_missing2(&tmp->nativeformats, prefformat & ~AST_FORMAT_SLINEAR);
 				tmp->rawreadformat =
 				tmp->rawwriteformat =
 				prefformat & ~AST_FORMAT_SLINEAR;
 			}
 		}
 		else {
-			tmp->nativeformats = prefformat;
+			ast_codec_pref_append_missing2(&tmp->nativeformats, prefformat);
 			tmp->rawreadformat = prefformat;
 			tmp->rawwriteformat = prefformat;
 		}
@@ -1188,9 +1188,8 @@
 	return tmp;
 }
 
-static struct ast_channel *phone_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *phone_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
-	int oldformat;
 	struct phone_pvt *p;
 	struct ast_channel *tmp = NULL;
 	char *name = data;
@@ -1203,7 +1202,7 @@
 	p = iflist;
 	while(p) {
 		if (p->mode == MODE_FXS ||
-		    format & (AST_FORMAT_G723_1 | AST_FORMAT_SLINEAR | AST_FORMAT_ULAW)) {
+		    formats->audio_bits & (AST_FORMAT_G723_1 | AST_FORMAT_SLINEAR | AST_FORMAT_ULAW)) {
 		    size_t length = strlen(p->dev + 5);
     		if (strncmp(name, p->dev + 5, length) == 0 &&
     		    !isalnum(name[length])) {
@@ -1218,14 +1217,6 @@
 	}
 	ast_mutex_unlock(&iflock);
 	restart_monitor();
-	if (tmp == NULL) {
-		oldformat = format;
-		format &= (AST_FORMAT_G723_1 | AST_FORMAT_SLINEAR | AST_FORMAT_ULAW);
-		if (!format) {
-			ast_log(LOG_NOTICE, "Asked to get a channel of unsupported format '%d'\n", oldformat);
-			return NULL;
-		}
-	}
 	return tmp;
 }
 
